package com.agiledeveloper;

import clojure.lang.LockingTransaction;

import java.util.concurrent.Callable;

public class AccountService {
  public void transfer(final Account from, final Account to, final int amount) throws Exception {
    LockingTransaction.runInTransaction(new Callable<Void>() {
      @Override
      public Void call() throws Exception {
        from.withdraw(amount);
        to.deposit(amount);
        return null;
      }
    });
  }

  public void withdraw(final Account from, final int amount, final Account constrainingAccount) throws Exception {
    LockingTransaction.runInTransaction(new Callable<Void>() {
      @Override
      public Void call() throws Exception {
        if (from.getBalance() + constrainingAccount.ensure() - amount >= 2000) {
          from.withdraw(amount);
        }
        return null;
      }
    });
  }
}
